//
//  FaceIdLocakViewController.swift
//  Discussions
//
//  Created by Mehedi Hasan on 19/5/21.
//  Copyright © 2021 Admin. All rights reserved.
//

import UIKit
import LocalAuthentication

class FaceIdLocakViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()

        faceIdLocak()
        
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        navigationController?.setNavigationBarHidden(true, animated: animated)
    }
    
    func faceIdLocak() {
        print("faceIdLocak")
        let context = LAContext()
            var error: NSError?

            if context.canEvaluatePolicy(.deviceOwnerAuthenticationWithBiometrics, error: &error) {
                let reason = "Identify yourself!"

                context.evaluatePolicy(.deviceOwnerAuthenticationWithBiometrics, localizedReason: reason) {
                    [weak self] success, authenticationError in

                    DispatchQueue.main.async {
                        if success {
                            let dvc = self?.storyboard?.instantiateViewController(withIdentifier: "ViewControllerID") as! ViewController
                            self?.navigationController?.pushViewController(dvc, animated: false)
                            
                        } else {
                            // error
                            let ac = UIAlertController(title: "Authentication failed", message: "You could not be verified; please try again.", preferredStyle: .alert)
                            ac.addAction(UIAlertAction(title: "OK", style: .default))
                            self?.present(ac, animated: true)
                        }
                    }
                }
            } else {
                // no biometry
                let ac = UIAlertController(title: "Biometry unavailable", message: "Your device is not configured for biometric authentication.", preferredStyle: .alert)
                ac.addAction(UIAlertAction(title: "OK", style: .default))
                self.present(ac, animated: true)
            }
    }
    

}
